﻿using Grpc.Core;
using Grpc.Net.Client;
using Snap;

var channel = GrpcChannel.ForAddress("https://snap-grpc.quodd.com");
var snapServiceClient = new SnapService.SnapServiceClient(channel);

// How to get a token: https://developer.quodd.com/docs/rest-api/post-generate-a-token
var metadata = new Metadata { { "Authorization", "Bearer TOKEN_HERE" } };

// SnapsRequest Example
Console.WriteLine("----- GetSnaps Request -----");
var snapsRequest = new SnapsRequest() { };
snapsRequest.Tickers.Add("SPY");
snapsRequest.Tickers.Add("META");

var response = snapServiceClient.GetSnaps(snapsRequest, metadata);
Console.WriteLine("GetSnaps Response:");
Console.WriteLine(response);

// SnapStreamRequest Example
Console.WriteLine("----- GetSnapsStream Request -----");
var snapStreamRequest = new SnapStreamRequest() { };
snapStreamRequest.Tickers.Add("MSFT");
snapStreamRequest.Tickers.Add("TSLA");

Console.WriteLine("GetSnapsStream Response:");
using var call = snapServiceClient.GetSnapsStream(snapStreamRequest, metadata);
while (await call.ResponseStream.MoveNext())
{
    Console.WriteLine(call.ResponseStream.Current);
}