const grpc = require("@grpc/grpc-js");
const protoLoader = require("@grpc/proto-loader");

let packageDefinition = protoLoader.loadSync("../protos/snap.proto", {
  keepCase: true,
});

let snapApi = grpc.loadPackageDefinition(packageDefinition).snap;

let client = new snapApi.SnapService(
  "snap-grpc.quodd.com",
  grpc.credentials.createSsl()
);

const metaData = new grpc.Metadata();
// How to get a token: https://developer.quodd.com/docs/rest-api/post-generate-a-token
metaData.add(
  "Authorization",
  "Bearer TOKEN_HERE"
);

// SnapsRequest Example
client.GetSnaps({
  tickers: ["SPY", "META"],
},metaData, function(error, response) {
  if (error) {
    console.log('Error: ' + error);
  }
  console.log(response);
  console.log('-----------------------------');
});

// SnapStreamRequest Example
const stream = client.GetSnapsStream(
  {
    tickers: ["MSFT", "TSLA"],
  },
  metaData
);

stream.on("data", function (data) {
  console.log(JSON.stringify(data, null, 4));
});
